<template>
    <div ref="threeRef"></div>
</template>
<script lang="ts">
import {Scene,PerspectiveCamera,WebGLRenderer,Color,AxesHelper,PlaneGeometry,MeshBasicMaterial,Mesh,BoxGeometry, SphereGeometry, DoubleSide} from 'three'
import { defineComponent, onMounted,ref} from 'vue'
import { OrbitControls } from 'three/examples/jsm/controls/OrbitControls.js'

export default defineComponent({
    setup() {

        const threeRef = ref();

        function init(){

            const scene=new Scene()
            const axes=new AxesHelper(20)
            scene.add(axes)

            const renderer=new WebGLRenderer({antialias:true})
            renderer.setClearColor(new Color(0xEEEEEE))
            renderer.setSize(window.innerWidth,window.innerHeight)


            const planeGeometry=new PlaneGeometry(80,20);
            const planeBasicMaterial=new MeshBasicMaterial({color:0xcccccc, side: DoubleSide});
            const plane=new Mesh(planeGeometry,planeBasicMaterial)
            plane.rotation.x=0.5*Math.PI;
            plane.position.set(40, 0, 10)
            scene.add(plane)

            //盒子几何体
            const cubeGeometry=new BoxGeometry(4,4,14)
            const cubeMaterial=new MeshBasicMaterial({color:0xff0000,wireframe:true});
            const cube=new Mesh(cubeGeometry,cubeMaterial)
            //cube.rotation.x=-0.5*Math.PI
            cube.position.x=10
            cube.position.y=3;
            cube.position.z=10;
            scene.add(cube)

            //球形几何体
            const sphereGeometry=new SphereGeometry(4,20,20);
            const sphereMaterial=new MeshBasicMaterial({color:0x77777ff,wireframe:true})
            const sphere=new Mesh(sphereGeometry,sphereMaterial);
            sphere.position.x=40
            sphere.position.y=4;
            sphere.position.z=10;
            scene.add(sphere);

            const camera=new PerspectiveCamera(45,window.innerWidth/window.innerHeight)
            camera.position.x=100;
            camera.position.y=100;
            camera.position.z=100;
            camera.lookAt(0,0,0)
            threeRef.value.appendChild(renderer.domElement)
            renderer.render(scene,camera)

            const controls = new OrbitControls(camera, renderer.domElement)
            controls.addEventListener('change', ()=>{
                renderer.render(scene,camera)
            })

        }

        onMounted(()=>{
            init();
        })
        return{
            threeRef
        }
    },
})
</script>